/*********************************************************************
*                                                                    *          
*                              FLY                                   *
*                           --E#Y#E--				     *
*                         ===MUSCLE===                               *
*                                                                    *
*********************************************************************/
#ifndef OPENGL_H_
#define OPENGL_H_
/* Header Files */
#include <cstdio>
#include <cstdlib>
#include <GL/glew.h>
#include <GL/gl.h>
#include <GL/glx.h>
#include <GL/glu.h>
#include "texture.h"
#include "uniform.h"
#include "win.h"
/* Define Key */
#define XK_space                         0x0020
#define XK_Escape                        0xff1b
#define XK_F1                            0xffbe
#define XK_F2                            0xffbf
#define XK_F3				 0xffc0
#define XK_F4				 0xffc1
#define XK_Left                          0xff51  
#define XK_Up                            0xff52  
#define XK_Right                         0xff53  
#define XK_Down                          0xff54  
#define XK_a                             0x0061
#define XK_b                             0x0062
#define XK_d                             0x0064
#define XK_e                             0x0065
#define XK_q                             0x0071 
#define XK_s                             0x0073 
#define XK_w                             0x0077
#define XK_n                             0x006e
#define XK_m                             0x006d
/* Define Pi */
#define PI 3.14159
#define ID 16

//---------------------------------------------------------------------------

/* Class FLY */
class FLY
{
private:
	/* Textures Coordinate */
	struct f_texture
	{
		GLfloat s;
		GLfloat t;
	};

	/* Init Triangles */
	struct f_triangles
	{
		GLfloat x;
		GLfloat y;
		GLfloat z;
	};

	/* Structure Float */
	struct f_float
	{
		struct f_texture tex;
		struct f_triangles tri;
	}gl;

public:
	/* Function */
	void loadPNG();
	void initGrid();
	void initLand(bool night);
	void textureShader();
	void GridView();
	void Landscape(bool cloud);
	void Cockpit();
	void process_event(XEvent report);
};

//---------------------------------------------------------------------------

#endif
